(use test)

(use directory-utils)

(test-assert (pathname? "abc/cbs.foo"))
(test-assert (pathname? "abc/cbs"))
(test-assert (pathname? ".abc"))
(test-assert (not (pathname? "")))

(test-assert (not (filename? "abc/cbs.foo")))
(test-assert (filename? "cbs.foo"))

(test-assert (not (dot-pathname? "abc/cbs.foo")))
(test-assert (dot-pathname? "/abc/.hide/hidden"))
(test-assert (not (dot-pathname? "/abc/cbs/./foo")))
(test-assert (not (dot-pathname? "/abc/cbs/../foo")))
(test-assert (dot-pathname? "/abc/cbs/../.foo"))
(test-assert (dot-pathname? "/abc/cbs/../.foo/bar"))

(test-assert (dot-filename? ".hide"))
(test-assert (not (dot-filename? "/abc/.hide/hidden")))
(test-assert (not (dot-filename? ".")))
(test-assert (not (dot-filename? "..")))

(test '("abc/cbs.foo") (remove-dotfiles '(".hide" "abc/cbs.foo")))

(test-assert (which-command-pathnames "mkdir"))
(test-assert (not (which-command-pathnames "93274030#$%)#)$()")))

(test "directory-fold" 1 (directory-fold (lambda (fn ct) (fx+ ct 1) ) 0 "." #:dotfiles? #f))

(test-assert (push-directory ".."))

(test-assert "directory-fold"
  (< 1 (directory-fold (lambda (fn ct) (fx+ ct 1) ) 0 "." #:dotfiles? #f)))

(test-assert (pop-toplevel-directory)) ;(pop-directory)

(test-exit)
